net.sf.saxon.om

## Interface DocumentInfo

- All Superinterfaces:
    Item, NodeInfo, PullEvent, Sequence, Source
  All Known Implementing Classes:
    AxiomDocumentWrapper, DocumentImpl, DocumentWrapper, DOM4JDocumentWrapper, FleetingDocumentNode, JDOM2DocumentWrapper, JDOMDocumentWrapper, SpaceStrippedDocument, TextFragmentValue, TinyDocumentImpl, TypeStrippedDocument, UnconstructedDocument, VirtualDocumentCopy, XOMDocumentWrapper

      public interface DocumentInfo
      extends NodeInfo

  This interface represents a document node as defined in the XPath 2.0 data model. It extends NodeInfo, which is used to represent any node. Every document node must be an instance of DocumentInfo.

  The interface supports two methods in addition to those for NodeInfo: one to find elements given their ID value, and one to locate unparsed entities. In addition, document nodes have an important property that is not true of nodes in general: two distinct Java DocumentInfo objects never represent the same document node. So the Java "==" operator returns the same result as the `NodeInfo.isSameNodeInfo(net.sf.saxon.om.NodeInfo)` method.

  This interface is part of the Saxon public API, and as such (from Saxon8.4 onwards) those methods that form part of the stable public API are labelled with a JavaDoc "since" tag to indicate when they were added to the product.

  Since:
    8.4
  Author:
    Michael H. Kay

- - ### Field Summary

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `ALL_NAMESPACES, IS_DTD_TYPE, IS_NILLED, LOCAL_NAMESPACES, NO_NAMESPACES`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `String[]` | `getUnparsedEntity(String name)` Get the unparsed entity with a given name
    `Iterator<String>` | `getUnparsedEntityNames()` Get the list of unparsed entities defined in this document
    `Object` | `getUserData(String key)` Get user data held in the document node.
    `boolean` | `isTyped()` Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED
    `NodeInfo` | `selectID(String id, boolean getParent)` Get the element with a given ID, if any
    `void` | `setUserData(String key, Object value)` Set user data on the document node.

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `atomize, compareOrder, comparePosition, copy, equals, generateId, getAttributeValue, getBaseURI, getColumnNumber, getConfiguration, getDeclaredNamespaces, getDisplayName, getDocumentNumber, getDocumentRoot, getFingerprint, getLineNumber, getLocalPart, getNameCode, getNamePool, getNodeKind, getParent, getPrefix, getRoot, getSchemaType, getStringValue, getSystemId, getTypeAnnotation, getURI, hasChildNodes, hashCode, isId, isIdref, isNilled, isSameNodeInfo, iterateAxis, iterateAxis`

    - ### Methods inherited from interface javax.xml.transform.Source

      `setSystemId`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getStringValueCS`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `head, iterate`

- - ### Method Detail

    - #### isTyped

          boolean isTyped()

      Ask whether the document contains any nodes whose type annotation is anything other than UNTYPED
      Returns:
        true if the document contains elements whose type is other than UNTYPED

    - #### selectID

          NodeInfo selectID(String id,
                          boolean getParent)

      Get the element with a given ID, if any
      Parameters:
        `id` - the required ID value
        `getParent` - true if running the element-with-id() function rather than the id() function; the difference is that in the case of an element of type xs:ID, the parent of the element should be returned, not the element itself.
      Returns:
        the element with the given ID, or null if there is no such ID present (or if the parser has not notified attributes as being of type ID)
      Since:
        8.4. Second argument added in 9.2.

    - #### getUnparsedEntityNames

          Iterator<String> getUnparsedEntityNames()

      Get the list of unparsed entities defined in this document
      Returns:
        an Iterator, whose items are of type String, containing the names of all unparsed entities defined in this document. If there are no unparsed entities or if the information is not available then an empty iterator is returned
      Since:
        9.1

    - #### getUnparsedEntity

          String[] getUnparsedEntity(String name)

      Get the unparsed entity with a given name
      Parameters:
        `name` - the name of the entity
      Returns:
        if the entity exists, return an array of two Strings, the first holding the system ID of the entity (as an absolute URI if possible), the second holding the public ID if there is one, or null if not. If the entity does not exist, the method returns null. Applications should be written on the assumption that this array may be extended in the future to provide additional information.
      Since:
        8.4

    - #### setUserData

          void setUserData(String key,
                         Object value)

      Set user data on the document node. The user data can be retrieved subsequently using `getUserData(java.lang.String)`
      Parameters:
        `key` - A string giving the name of the property to be set. Clients are responsible for choosing a key that is likely to be unique. Must not be null. Keys used internally by Saxon are prefixed "saxon:".
        `value` - The value to be set for the property. May be null, which effectively removes the existing value for the property.

    - #### getUserData

          Object getUserData(String key)

      Get user data held in the document node. This retrieves properties previously set using `setUserData(java.lang.String, java.lang.Object)`
      Parameters:
        `key` - A string giving the name of the property to be retrieved.
      Returns:
        the value of the property, or null if the property has not been defined.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.